/******************************************************************************
 * shadow.cpp 
 * implements the base shadow class
 * Copyright (C) 2010 Marc Gissler <gisslerm@informatik.uni-freiburg.de>
 ******************************************************************************/
#include "shadow.h"
#include "volume_shadow.h"
#include "shadowmap.h"

const std::string ShadowMethods[2] = {"volume-shadow", "shadow-map" };

CShadow::CShadow()
{
}

CShadow::~CShadow()
{
}

CShadow* CShadow::instantiateShadow(std::string strMethod)
{
	if(strMethod == ShadowMethods[0])
		return new CVolumeShadow();
	else if (strMethod == ShadowMethods[1])
		return new CShadowMap();
	else
		return 0;
}
