/******************************************************************************
 * viewer.h 
 * implements the viewer class and static viewer (to implement some of the  glut callback functions)
 * Copyright (C) 2010 Marc Gissler <gisslerm@informatik.uni-freiburg.de>
 ******************************************************************************/
#ifndef VIEWER_H
#define VIEWER_H

#include "globals.h"

// ------------------------------------------------------------
// forward declarations
// 

class CShadow;

// ------------------------------------------------------------
// defines thes viewer class
// 

class CViewer
{
	// constructor/destructor
	CViewer();
	~CViewer();

	static CViewer* m_pInstance;

public:
	// destroys the single viewer instance
	static void destroyViewer();
	
	// gets the single viewer instance
	static CViewer* getViewer();

	// initializes the viewer
	void initialize(int argc, char **argv);

	// calls the main loop from GLut
	void loop();

	// draws the meshes
	void draw();
};

// namespace for static functions (needed to be able to overload the GLut functions)
namespace StaticViewer
{
	// displays all meshes in the scene
	void display();
	
	// resizes the OpenGL window
	void reshape(int w, int h);

	// handles a mouse click
	void handleMouseClick(int button, int state, int x, int y);

	// handles a mouse move
	void handleMouseMove(int x, int y);
}

#endif
